

import unohelper

from com.sun.star.frame import (XStatusListener, 
	XDispatchProvider, 
	XDispatch, XControlNotificationListener, FeatureStateEvent)
from com.sun.star.lang import XInitialization, XServiceInfo


IMPL_NAME = "mytools.frame.PhTest"


class Dispatcher(unohelper.Base, XDispatch, XControlNotificationListener):
	def __init__(self, frame):
		self.frame = frame
		self.state = False
		self.listener = None
	
	# XDispatch
	def dispatch(self, url, args):
		self.state = not self.state
		ev = self.create_simple_event(url, self.state)
		self.listener.statusChanged(ev)
		
		self.do_something()
	
	def addStatusListener(self, listener, url):
		self.listener = listener
	
	def removeStatusListener(self, listener, url): pass
	
	# XControlNotificationListener
	def controlEvent(self, ev): pass
	
	def create_simple_event(self, url, state, enabled=True):
		return FeatureStateEvent(self, url, "", enabled, False, state)
	
	
	def do_something(self):
		if self.frame:
			controller = self.frame.getController()
			doc = controller.getModel()
			if doc.supportsService("com.sun.star.text.TextDocument"):
				doc.getText().setString("New state: %s" % self.state)


class Ph(unohelper.Base, XInitialization, XDispatchProvider, XServiceInfo):
	def __init__(self, ctx, *args):
		self.frame = None
	
	# XInitialization
	def initialize(self, args):
		if len(args) > 0:
			self.frame = args[0]
	
	# XDispatchProvider
	def queryDispatch(self, url, name, flag):
		dispatch = None
		if url.Protocol == "mytools.frame.Ph:":
			try:
				dispatch = Dispatcher(self.frame)
			except Exception as e:
				print(e)
		return dispatch
	
	def queryDispatches(self, descs):
		pass
	
	# XServiceInfo
	def supportsService(self, name):
		return (name == "com.sun.star.frame.ProtocolHandler")
	def getImplementationName(self):
		return IMPL_NAME
	def getSupportedServiceNames(self):
		return ("com.sun.star.frame.ProtocolHandler",)

g_ImplementationHelper = unohelper.ImplementationHelper()
g_ImplementationHelper.addImplementation(
	Ph,
	IMPL_NAME,
	("com.sun.star.frame.ProtocolHandler",),)
